SystemOrganization addCategory: #MultiDimensionalEnumeration!
SystemOrganization addCategory: #'MultiDimensionalEnumeration-for'!
SystemOrganization addCategory: #'MultiDimensionalEnumeration-for-test'!
SystemOrganization addCategory: #'MultiDimensionalEnumeration-blockAdaptor'!
SystemOrganization addCategory: #'MultiDimensionalEnumeration-blockAdaptor-test'!
SystemOrganization addCategory: #'MultiDimensionalEnumeration-test'!

!SequenceableCollection methodsFor: '*multidimensionalenumeration' stamp: 'hjo 2/22/2012 23:57'!
multiDimensionalCollect: aBlockContext
	
	^MultiDimensionalCollect new
		domains: self;
		block: aBlockContext;
		run  ! !

!SequenceableCollection methodsFor: '*multidimensionalenumeration' stamp: 'hjo 2/22/2012 23:58'!
multiDimensionalDo: aBlockContext 

	^MultiDimensionalDo new
		domains: self;
		block: aBlockContext;
		run.    
! !

!SequenceableCollection methodsFor: '*multidimensionalenumeration' stamp: 'hjo 2/22/2012 23:58'!
multiDimensionalSelect: aBlockContext 

	^MultiDimensionalSelect new
		domains: self;
		block: aBlockContext;
		run.    ! !

TestCase subclass: #AdaptedMultiDimensionalEnumerationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration-test'!

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:05'!
testCollect1

	| collect |
	collect := MultiDimensionalCollect new.
	collect domains: {1 to: 4}.
	collect blockOfOneArrayArgument: [:arr| arr first*10 ].
	self assert: {10. 20. 30. 40} equals: collect run.    ! !

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:07'!
testCollect2

	| collect |
	collect := MultiDimensionalCollect new.
	collect domains: {1 to: 4. 2 to: 7}.
	collect blockOfOneArrayArgument: [:arr | arr first*10+arr second].
	self assert: {12. 13. 14. 15. 16. 17. 22. 23. 24. 25. 26. 27. 32. 33. 34. 35. 36. 37. 42. 43. 44. 45. 46. 47 } equals: collect run.    ! !

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:08'!
testCollect3

	| collect |
	collect := MultiDimensionalCollect new.
	collect domains: {1 to: 4. 2 to: 7. 8 to: 9}.
	collect blockOfOneArrayArgument: [:arr| (arr first*100)+(arr second*10)+arr third].
	self assert: { 128 . 129 . 138 . 139 . 148 . 149 . 158 . 159 . 168 . 169 . 178 . 179 . 228 . 229 . 238 . 239 . 248 . 249 . 258 . 259 . 268 . 269 . 278 . 279 . 328 . 329 . 338 . 339 . 348 . 349 . 358 . 359 . 368 . 369 . 378 . 379 . 428 . 429 . 438 . 439 . 448 . 449 . 458 . 459 . 468 . 469 . 478 . 479 } equals: collect run.    ! !

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:08'!
testDo1

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4}.
	tape := OrderedCollection new.
	do blockOfOneArrayArgument: [:arr| tape addLast: arr first*10 ].
	do run.
	self assert: {10. 20. 30. 40} equals: tape asArray.    ! !

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:08'!
testDo2

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4. 2 to: 7}.
	tape := OrderedCollection new.
	do blockOfOneArrayArgument: [:arr | tape addLast: arr first*10+arr second].
	do run.
	self assert: {12. 13. 14. 15. 16. 17. 22. 23. 24. 25. 26. 27. 32. 33. 34. 35. 36. 37. 42. 43. 44. 45. 46. 47 } equals: tape asArray.    ! !

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:08'!
testDo3

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4. 2 to: 7. 8 to: 9}.
	tape := OrderedCollection new.
	do blockOfOneArrayArgument: [:arr| tape addLast: (arr first*100)+(arr second*10)+arr third].
	do run.
	self assert: { 128 . 129 . 138 . 139 . 148 . 149 . 158 . 159 . 168 . 169 . 178 . 179 . 228 . 229 . 238 . 239 . 248 . 249 . 258 . 259 . 268 . 269 . 278 . 279 . 328 . 329 . 338 . 339 . 348 . 349 . 358 . 359 . 368 . 369 . 378 . 379 . 428 . 429 . 438 . 439 . 448 . 449 . 458 . 459 . 468 . 469 . 478 . 479 } equals: tape asArray.    ! !

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:09'!
testDoReturnsDomains

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4. 2 to: 7. 8 to: 9}.
	tape := OrderedCollection new.
	do blockOfOneArrayArgument: [:arr| tape addLast: (arr first*100)+(arr second*10)+arr third].
	self assert: do domains equals: do run.! !

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:09'!
testSelect1

	| select |
	select := MultiDimensionalSelect new.
	select domains: {1 to: 4}.
	select blockOfOneArrayArgument: [:arr| (arr first rem: 3) = 0 ].
	self assert: {{3}} equals: select run.    ! !

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:09'!
testSelect2

	| select |
	select := MultiDimensionalSelect new.
	select domains: {1 to: 4. 2 to: 7}.
	select blockOfOneArrayArgument: [:arr | (arr first+arr second rem: 3) = 0 ].
	self assert: {{1 . 2}. {1 . 5}. {2 . 4}. {2 . 7}. {3. 3}. {3 . 6}. {4 . 2}. {4 . 5}} equals: select run.    ! !

!AdaptedMultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 20:12'!
testSelectedCollect

	| select |
	select := MultiDimensionalSelectedCollect new.
	select domains: {1 to: 4. 2 to: 7}.
	select collectingBlockOfOneArrayArgument: [:arr | (arr first*10)+arr second].
	select selectingBlock: [:num| (num rem: 3) = 0].  
	self assert: {12. 15. 24. 27. 33. 36. 42. 45} equals: select run.    ! !

TestCase subclass: #BlockArgumentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration-blockAdaptor-test'!

!BlockArgumentTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 19:53'!
testAdaptorBehavior
self assert: ((BlockOfAnyNumberArguments new blockOfOneArrayArgument: [:array| array first + array second]) valueWithArguments: {1. 2}) equals: 3.

! !

!BlockArgumentTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 19:56'!
testBasicBehavior
self assert: ([:a :b| a+b] value: 1 value: 2) equals: 3.
self assert: ([:a :b| a+b] valueWithArguments: {1. 2}) equals: 3.
self should: [[:a :b| a+b] value: {1. 2}] raise: Error.

self should: [[:array| array first + array second] value: 1 value: 2] raise: Error.
self should: [[:array| array first + array second] valueWithArguments: {1. 2}] raise: Error.
self assert: ([:array| array first + array second] value: {1. 2}) equals: 3.

! !

TestCase subclass: #ForStatementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration-for-test'!

!ForStatementTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 19:14'!
testDepth1
|sum f|
sum := 0.
f := ForStatement new.
f domain: (1 to: 3).
f loopBlock: [:a| sum := a + sum].
f run.
self assert: sum equals: 6.! !

!ForStatementTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 19:14'!
testDepth1check
|sum f|
sum := 0.
f := ForStatement new.
f domain: (1 to: 3).
f checkingBlock: [:a| a odd].
f loopBlock: [:a| sum := a + sum].
f run.
self assert: sum equals: 4.! !

!ForStatementTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 19:27'!
testDepth2
|sum f|
sum := OrderedCollection new.
f := ForStatement new.
f domain: (1 to: 10).
f checkingBlock: [:e| e = 5].

f subFor: 
	(ForStatement new 
		domain: (1 to: 3)).

f loopBlock: [:a :b| sum add: {a. b}].
f run.
self assert: sum equals: (OrderedCollection with: {5. 1} with: {5. 2}  with: {5. 3})! !

!ForStatementTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 19:28'!
testDepth2check
|sum f|
sum := OrderedCollection new.
f := ForStatement new.
f domain: (1 to: 10).
f checkingBlock: [:e| e = 5].

f subFor: 
	(ForStatement new 
		domain: (1 to: 6); 
		checkingBlock: [:e|e=2]).

f loopBlock: [:a :b| sum add: {a. b}].
f run.
self assert: sum equals: (OrderedCollection with: {5. 2})! !

!ForStatementTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 19:27'!
testDepth2checkTrue
|sum f|
sum := OrderedCollection new.
f := ForStatement new.
f domain: (1 to: 10).
f checkingBlock: [:e| e = 5].

f subFor: 
	(ForStatement new 
		domain: (1 to: 3); 
		checkingBlock: [:e|true]).

f loopBlock: [:a :b| sum add: {a. b}].
f run.
self assert: sum equals: (OrderedCollection with: {5. 1} with: {5. 2}  with: {5. 3})! !

TestCase subclass: #MultiDimensionalEnumerationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration-test'!

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:11'!
testCollect1

	| collect |
	collect := MultiDimensionalCollect new.
	collect domains: {1 to: 4}.
	collect block: [:x| x*10 ].
	self assert: {10. 20. 30. 40} equals: collect run.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:14'!
testCollect2

	| collect |
	collect := MultiDimensionalCollect new.
	collect domains: {1 to: 4. 2 to: 7}.
	collect block: [:x :y | x*10+y].
	self assert: {12. 13. 14. 15. 16. 17. 22. 23. 24. 25. 26. 27. 32. 33. 34. 35. 36. 37. 42. 43. 44. 45. 46. 47 } equals: collect run.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:15'!
testCollect3

	| collect |
	collect := MultiDimensionalCollect new.
	collect domains: {1 to: 4. 2 to: 7. 8 to: 9}.
	collect block: [:x :y :z| (x*100)+(y*10)+z].
	self assert: { 128 . 129 . 138 . 139 . 148 . 149 . 158 . 159 . 168 . 169 . 178 . 179 . 228 . 229 . 238 . 239 . 248 . 249 . 258 . 259 . 268 . 269 . 278 . 279 . 328 . 329 . 338 . 339 . 348 . 349 . 358 . 359 . 368 . 369 . 378 . 379 . 428 . 429 . 438 . 439 . 448 . 449 . 458 . 459 . 468 . 469 . 478 . 479 } equals: collect run.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 19:18'!
testDo1

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4}.
	tape := OrderedCollection new.
	do block: [:x| tape addLast: x*10 ].
	do run.
	self assert: {10. 20. 30. 40} equals: tape asArray.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 19:20'!
testDo2

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4. 2 to: 7}.
	tape := OrderedCollection new.
	do block: [:x :y | tape addLast: x*10+y].
	do run.
	self assert: {12. 13. 14. 15. 16. 17. 22. 23. 24. 25. 26. 27. 32. 33. 34. 35. 36. 37. 42. 43. 44. 45. 46. 47 } equals: tape asArray.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 19:25'!
testDo3

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4. 2 to: 7. 8 to: 9}.
	tape := OrderedCollection new.
	do block: [:x :y :z| tape addLast: (x*100)+(y*10)+z].
	do run.
	self assert: { 128 . 129 . 138 . 139 . 148 . 149 . 158 . 159 . 168 . 169 . 178 . 179 . 228 . 229 . 238 . 239 . 248 . 249 . 258 . 259 . 268 . 269 . 278 . 279 . 328 . 329 . 338 . 339 . 348 . 349 . 358 . 359 . 368 . 369 . 378 . 379 . 428 . 429 . 438 . 439 . 448 . 449 . 458 . 459 . 468 . 469 . 478 . 479 } equals: tape asArray.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:00'!
testDoReturnsDomains

	| do tape |
	do := MultiDimensionalDo new.
	do domains: {1 to: 4. 2 to: 7. 8 to: 9}.
	tape := OrderedCollection new.
	do block: [:x :y :z| tape addLast: (x*100)+(y*10)+z].
	self assert: do domains equals: do run.! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:20'!
testSelect1

	| select |
	select := MultiDimensionalSelect new.
	select domains: {1 to: 4}.
	select block: [:x| (x rem: 3) = 0 ].
	self assert: {{3}} equals: select run.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:22'!
testSelect2

	| select |
	select := MultiDimensionalSelect new.
	select domains: {1 to: 4. 2 to: 7}.
	select block: [:x :y | (x+y rem: 3) = 0 ].
	self assert: {{1 . 2}. {1 . 5}. {2 . 4}. {2 . 7}. {3. 3}. {3 . 6}. {4 . 2}. {4 . 5}} equals: select run.    ! !

!MultiDimensionalEnumerationTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/29/2012 23:00'!
testSelectedCollect

	| select |
	select := MultiDimensionalSelectedCollect new.
	select domains: {1 to: 4. 2 to: 7}.
	select collectingBlock: [:x :y | (x*10)+y].
	select selectingBlock: [:num| (num rem: 3) = 0].  
	self assert: {12. 15. 24. 27. 33. 36. 42. 45} equals: select run.    ! !

Error subclass: #MultiDimensionalEnumerationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration'!

Object subclass: #BlockOfAnyNumberArguments
	instanceVariableNames: 'blockOfOneArrayArgument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration-blockAdaptor'!

!BlockOfAnyNumberArguments methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 19:53'!
blockOfOneArrayArgument: aBlockClosure 
blockOfOneArrayArgument := aBlockClosure ! !

!BlockOfAnyNumberArguments methodsFor: 'as yet unclassified' stamp: 'HwaJong 11/29/2012 19:55'!
valueWithArguments: anArray
^blockOfOneArrayArgument value: anArray ! !

Object subclass: #ForStatement
	instanceVariableNames: 'domain checkingBlock loopBlock subFor loopPosition superFor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration-for'!

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 17:42'!
argumentsForLoopBlock
	^ (superFor isNil ifTrue: [ {}  ] ifFalse: [ superFor argumentsForLoopBlock ]) , {(self objectInDomain)}! !

!ForStatement methodsFor: 'testing' stamp: 'HwaJong 11/29/2012 19:08'!
checkIsPass
	^ checkingBlock isNil or: [checkingBlock value: self objectInDomain]! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 16:14'!
checkingBlock
	^ checkingBlock! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 16:14'!
checkingBlock: anObject
	checkingBlock := anObject! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 16:14'!
domain
	^ domain! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 16:14'!
domain: anObject
	domain := anObject! !

!ForStatement methodsFor: 'running' stamp: 'HwaJong 11/29/2012 18:58'!
increaseLoopPositionBy1
	loopPosition := loopPosition + 1! !

!ForStatement methodsFor: 'initialize-release' stamp: 'HwaJong 11/29/2012 16:18'!
initialize
super initialize.
loopPosition := 0.! !

!ForStatement methodsFor: 'testing' stamp: 'HwaJong 11/29/2012 16:31'!
isLeafFor
^subFor isNil! !

!ForStatement methodsFor: 'testing' stamp: 'HwaJong 11/29/2012 16:27'!
isTerminated
^domain size < loopPosition! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 16:14'!
loopBlock
	^ loopBlock! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 16:32'!
loopBlock: anObject
	self isLeafFor 
		ifTrue: [loopBlock := anObject]
		ifFalse: [subFor loopBlock: anObject].
	! !

!ForStatement methodsFor: 'testing' stamp: 'HwaJong 11/29/2012 18:51'!
loopingHasNotStartedYet
	^ loopPosition = 0! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 17:34'!
objectInDomain
	^ domain at: loopPosition! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 17:00'!
positions
	^self isLeafFor 
		ifTrue: [{loopPosition}]
		ifFalse: [{loopPosition}, subFor positions]! !

!ForStatement methodsFor: 'running' stamp: 'HwaJong 11/29/2012 19:03'!
run
	self setLoopPositionTo1.
	[ self isTerminated ] whileFalse: [ self step ]! !

!ForStatement methodsFor: 'running' stamp: 'HwaJong 11/29/2012 19:03'!
setLoopPositionTo1
	loopPosition := 1! !

!ForStatement methodsFor: 'running' stamp: 'HwaJong 11/29/2012 19:06'!
step
	self loopingHasNotStartedYet
		ifTrue: [ self setLoopPositionTo1 ].
	self isTerminated
		ifTrue: [ ^ self ].
	self checkIsPass
		ifTrue: [ self stepWhenCheckPass ]
		ifFalse: [ self stepWhenCheckFail ]! !

!ForStatement methodsFor: 'running' stamp: 'HwaJong 11/29/2012 19:00'!
stepWhenCheckFail
	self increaseLoopPositionBy1! !

!ForStatement methodsFor: 'running' stamp: 'HwaJong 11/29/2012 19:01'!
stepWhenCheckPass
	self isLeafFor
		ifTrue: [ self stepWhenCheckPassAndAtLeaf ]
		ifFalse: [ self stepWhenCheckPassAndHasSub ]! !

!ForStatement methodsFor: 'running' stamp: 'HwaJong 11/29/2012 19:00'!
stepWhenCheckPassAndAtLeaf
	loopBlock valueWithArguments: self argumentsForLoopBlock.
	self increaseLoopPositionBy1! !

!ForStatement methodsFor: 'running' stamp: 'HwaJong 11/29/2012 19:01'!
stepWhenCheckPassAndHasSub
	subFor isTerminated
		ifTrue: [ 
			subFor initialize.
			self increaseLoopPositionBy1 ]
		ifFalse: [ subFor step ]! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 16:14'!
subFor
	^ subFor! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 16:30'!
subFor: anObject
	subFor := anObject.
	anObject superFor: self.! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 16:29'!
superFor
	^ superFor! !

!ForStatement methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 16:29'!
superFor: anObject
	superFor := anObject! !

Object subclass: #MultiDimensionalEnumeration
	instanceVariableNames: 'block domains'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration'!

MultiDimensionalEnumeration subclass: #MultiDimensionalCollect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration'!

!MultiDimensionalCollect methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:39'!
handleEvaluation: anObject to: anArray index: anInteger args: argsArray

	anArray at: (anInteger+1) put: anObject.! !

!MultiDimensionalCollect methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:33'!
initialAllocation

	^Array new: ((domains collect: #size) reduce: [:a :b| a*b]).! !

!MultiDimensionalCollect methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:53'!
returnWithAllocation: anArray 

	^anArray! !

MultiDimensionalEnumeration subclass: #MultiDimensionalDo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration'!

!MultiDimensionalDo methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:51'!
handleEvaluation: anObject to: anUndefinedObject index: anInteger args: anArray 
! !

!MultiDimensionalDo methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:49'!
initialAllocation

	^nil! !

!MultiDimensionalDo methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:51'!
returnWithAllocation: anUndefinedObject 

	^domains! !

!MultiDimensionalEnumeration methodsFor: 'accessing' stamp: 'hjo 2/22/2012 20:24'!
block: aBlockClosure 

	block := aBlockClosure! !

!MultiDimensionalEnumeration methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 20:06'!
blockOfOneArrayArgument: aBlockClosure 
self block: (BlockOfAnyNumberArguments new blockOfOneArrayArgument: aBlockClosure)! !

!MultiDimensionalEnumeration methodsFor: 'accessing' stamp: 'hjo 2/22/2012 20:24'!
domains

	^ domains! !

!MultiDimensionalEnumeration methodsFor: 'accessing' stamp: 'hjo 2/22/2012 20:24'!
domains: anArray 

	domains := anArray! !

!MultiDimensionalEnumeration methodsFor: 'as yet unclassified' stamp: 'hjo 2/29/2012 21:16'!
run

	| mqr args allocated |
	mqr := MultiQuoAndRem new.
	mqr dividers: (domains collect: #size).
	
	args := Array new: domains size.
	allocated := self initialAllocation.
	
	0 to: ((domains collect: #size) reduce: [:a :b| a*b])-1 do: [:index|
		(mqr indexValue: index) keysAndValuesDo: [:k :v | args at: k put: ((domains at:k) at:v) ].  
		[self handleEvaluation: (block valueWithArguments: args) to: allocated index: index args: args] on: MultiDimensionalEnumerationError do: [:exp| "ignore"].
		].
	^self returnWithAllocation: allocated.! !

MultiDimensionalEnumeration subclass: #MultiDimensionalSelect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration'!

!MultiDimensionalSelect methodsFor: 'as yet unclassified' stamp: 'hjo 6/30/2012 08:15'!
handleEvaluation: aBoolean to: aWriteStream index: aSmallInteger args: anArray 

	aBoolean ifTrue: [aWriteStream nextPut: (self reformToBePutInSelectingStream: anArray)].! !

!MultiDimensionalSelect methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:37'!
initialAllocation

	^WriteStream on: Array new.! !

!MultiDimensionalSelect methodsFor: 'as yet unclassified' stamp: 'hjo 6/30/2012 08:15'!
reformToBePutInSelectingStream: anArray

	^anArray copy! !

!MultiDimensionalSelect methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2012 20:53'!
returnWithAllocation: aWriteStream 

	^aWriteStream contents.! !

MultiDimensionalSelect subclass: #MultiDimensionalSelectedCollect
	instanceVariableNames: 'selectingBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiDimensionalEnumeration'!

!MultiDimensionalSelectedCollect methodsFor: 'accessing' stamp: 'hjo 6/29/2012 22:49'!
collectingBlock

	^block! !

!MultiDimensionalSelectedCollect methodsFor: 'accessing' stamp: 'hjo 6/29/2012 22:50'!
collectingBlock: aBlock

	"[:a :b :c|  a * b  - c  ]"
	block := aBlock! !

!MultiDimensionalSelectedCollect methodsFor: 'accessing' stamp: 'HwaJong 11/29/2012 20:11'!
collectingBlockOfOneArrayArgument: aBlock

	"[:a :b :c|  a * b  - c  ]"
	self blockOfOneArrayArgument: aBlock ! !

!MultiDimensionalSelectedCollect methodsFor: 'as yet unclassified' stamp: 'hjo 6/30/2012 08:15'!
reformToBePutInSelectingStream: anObject

	^anObject! !

!MultiDimensionalSelectedCollect methodsFor: 'as yet unclassified' stamp: 'hjo 6/29/2012 22:55'!
run

	| mqr args allocated collected |
	mqr := MultiQuoAndRem new.
	mqr dividers: (domains collect: #size).
	
	args := Array new: domains size.
	allocated := self initialAllocation.
	
	0 to: ((domains collect: #size) reduce: [:a :b| a*b])-1 do: [:index|
		(mqr indexValue: index) keysAndValuesDo: [:k :v | args at: k put: ((domains at:k) at:v) ].  
		collected := block valueWithArguments: args.
		[self handleEvaluation: (selectingBlock value: collected) to: allocated index: index args: collected] on: MultiDimensionalEnumerationError do: [:exp| "ignore"].
		].
	^self returnWithAllocation: allocated.! !

!MultiDimensionalSelectedCollect methodsFor: 'accessing' stamp: 'hjo 6/29/2012 22:48'!
selectingBlock
	^ selectingBlock! !

!MultiDimensionalSelectedCollect methodsFor: 'accessing' stamp: 'hjo 6/29/2012 22:49'!
selectingBlock: aBlock

	self assert: [ aBlock numArgs = 1 ].
	selectingBlock := aBlock! !
